pro readdata,directory=directory, int_read=int_read, skip=skip, full=full, sideband=sideband, rx=rx, band_read=band_read, old=old
;yes
;=Task:READDATA --- To read data from specified directory
;#Type: i/o
;
;+Use:
;      READDATA will read raw SMA data from, by default, the current directory. 
;      If you want to read a data set called mydata from a different directory,
;      /home/smauser/ for example,  you can use
;      >readdata,dir='/home/smauser/mydata'
;      Specifying the directory will change the default to the specified 
;      directory.
;
;&history
;------------------------------------------------------------------------
;      cykuo 10feb04 adapting the header
;------------------------------------------------------------------------ 

common global
common data_set
common wlm

;print,directory
;print,keyword_set(directory) 

if not keyword_set(sideband) then sideband=0
if not keyword_set(rx) then rx=0
if not keyword_set(int_read) then int_read=0
if not keyword_set(band_read) then band_read=0

if keyword_set(directory) then begin
    nchar = strlen(directory)
    checkslash = strmid(directory,nchar-1,1)
    if ( strmatch(checkslash,'/') le 0 ) then directory = directory + '/'
    e.idl_bcp=directory

    count = 0
    result = findfile(e.idl_bcp+'in_read',count=count)
    if (count eq 0) then begin
        print,'could not find file ',e.idl_bcp+'in_read'
        return
    endif
    count = 0
    result = findfile(e.idl_bcp+'bl_read',count=count)
    if (count eq 0) then begin
        print,'could not find file ',e.idl_bcp+'bl_read'
        return
    endif
    count = 0
    result = findfile(e.idl_bcp+'sp_read',count=count)
    if (count eq 0) then begin
        print,'could not find file ',e.idl_bcp+'sp_read'
        return
    endif
    count = 0
    result = findfile(e.idl_bcp+'codes_read',count=count)
    if (count eq 0) then begin
        print,'could not find file ',e.idl_bcp+'codes_read'
        return
    endif
    count = 0
    result = findfile(e.idl_bcp+'sch_read',count=count)
    if (count eq 0) then begin
        print,'could not find file ',e.idl_bcp+'sch_read'
        return
    endif

    if keyword_set(full) then begin
       result=dbi_read_data()
       res=dat_list(s_l,/reset)
       distinct_bands=uti_distinct(sp[psl].iband,nbands,/many_repeat)
       bw=(nbands-1.)*82.
    endif else begin
       if not keyword_set(old) then begin
          iblfix=0
          result=dbi_head_read2(int_read=int_read,sideband=sideband,rx=rx,band_read=band_read,bw=bw,iblfix=iblfix)
          if result lt 0 then return
          result=dbi_chan_read2(int_read=int_read)
          if result lt 0 then result=dbi_chan_read()
          if iblfix then uti_uvw_fix
       endif else begin
          result=dbi_head_read_short()
          result=dbi_chan_read_short()
          if result lt 0 then result=dbi_chan_read()
          res=dat_list(s_l,/reset)
          distinct_bands=uti_distinct(sp[psl].iband,nbands,/many_repeat)
          bw=(nbands-1.)*82.
       endelse
;       if result lt 0 then result=dbi_chan_read()
    endelse
 endif else begin
    if keyword_set(full) then begin
       result=dbi_read_data()
       res=dat_list(s_l,/reset)
       distinct_bands=uti_distinct(sp[psl].iband,nbands,/many_repeat)
       bw=(nbands-1.)*82.
    endif else begin
       if not keyword_set(old) then begin
          iblfix=0
          result=dbi_head_read2(int_read=int_read,sideband=sideband,rx=rx,band_read=band_read,bw=bw,iblfix=iblfix)
          if result lt 0 then return
          result=dbi_chan_read2(int_read=int_read)
          if result lt 0 then result=dbi_chan_read()
          if iblfix then uti_uvw_fix
       endif else begin
          result=dbi_head_read_short()
          result=dbi_chan_read_short() 
          if result lt 0 then result=dbi_chan_read()
          res=dat_list(s_l,/reset)
          distinct_bands=uti_distinct(sp[psl].iband,nbands,/many_repeat)
          bw=(nbands-1.)*82.
       endelse
;       if result lt 0 then result=dbi_chan_read()
    endelse
 endelse
if not keyword_set(band_read) then begin
   res=dat_list(s_l,'"band" like "c"',/reset,/no_notify)
   if abs(sp[psl[0]].fres) ne bw then sp[psl].fres = (sp[psl].fres/abs(sp[psl].fres)) * bw
   res=dat_list(s_l,/reset)
endif else begin
   i=where(band_read eq 'c1' or band_read eq 'c2',count)
   if count gt 0 then begin
      res=dat_list(s_l,'"band" like "c"',/reset,/no_notify)
      sp[psl].fres=(sp[psl].fres/abs(sp[psl].fres)) * bw
      res=dat_list(s_l,/reset)
   endif
endelse

p=strpos(c.blcd,'-')
;realants=uti_distinct([strmid(c.blcd,0,1),strmid(c.blcd,2)],nants)
realants=uti_distinct([strmid(c.blcd,0,1#p),strmid(c.blcd,1#p+1)],nants)
realants=realants[sort(fix(realants))]
for i=0, nants-1 do begin
   j=where(c.tel1 eq realants[i],count)
   if count eq 0 then uti_addhdr,ant=realants[i]
endfor

;if not iblfix then begin
   lat=19.82420526391d/57.29577951
   m1=[[-sin(lat),0,cos(lat)],[0,1,0],[cos(lat),0,sin(lat)]]
   bls=uti_distinct(c.blcd(bl[pbl].iblcd),nbls,/many_repeat)
   bflag=0
   list=""
   for i=0,nbls-1 do begin
      result=dat_list(s_l,'"wt" gt "0" and "blcd" eq "'+bls[i]+'"',/no_notify,/reset)
      h=in[pil[0]].ha*15.d*!dpi/180.d
      dec=in[pil[0]].decr
      m2=[[sin(h),cos(h),0],[-sin(dec)*cos(h),sin(dec)*sin(h),cos(dec)],$
        [cos(dec)*cos(h),-cos(dec)*sin(h),sin(dec)]]
      neu=[bl[pbl[0]].bln,bl[pbl[0]].ble,bl[pbl[0]].blu]
      neu=transpose(neu)
      klam=1000.d*0.299792458d/sp[psl[0]].fsky
      uvw=reform(m2##m1##neu)/klam
      if (abs(bl[pbl[0]].u-uvw[0])*klam gt 0.5) or (abs(bl[pbl[0]].v-uvw[1])*klam gt 0.5) or (abs(bl[pbl[0]].w-uvw[2])*klam gt 0.5) then begin
         bflag=1
         list=[list,bls[i]]
         print,'UVW coords for '+bls[i]+' will be fixed !'
      endif
   endfor
   if bflag then begin
      list=list[1:n_elements(list)-1]
      select,baseline=list,/reset
      uti_uvw_fix
   endif
;endif
res=dat_list(s_l,/reset)

end




